function NIMCoreClass() {
  const SDK = require('../NIM/NIM_Web_SDK_v8.5.1')
  const Recorder = require('./recorder')
  var data = {};
  var nim = {};
  var recorder = null;// 录音帮助类实例
  var currentsessionId = null;
  var onXTTZSessionUpadate = null;// 系统通知更新
  var onSessionMessageUpdate = null;// 会话内容更新
  var onSessionsListUpdate = null;// 当会话列表更新
  var onFriendsListUpdate = null;// 好友列表刷新
  var onTeamsListUpdate = null;// 群聊列表刷新
  var onSendMsgDone = null;// 发送成功反馈。针对直接对联系人发起消息时没有sessionid时候使用
  var addTeamCallback = null;// 创建成功后要进入群聊界面。此时需要获取群id。通过此方法返回
  var getTeamMemberCallback = null;// 获取群成员的回调

  var editFriendAlias = ''; // 添加人员的昵称
  var getUserNick = null;
  this.recordInit = function() {
    navigator.mediaDevices.getUserMedia({ audio: true }).then(function (stream) {
      var input = new AudioContext().createMediaStreamSource(stream);
      recorder = new Recorder(input);
    });
  }
  this.startRecordVoice = function() {
    recorder.record();
  }
  this.endRecordVoice = function() {
    recorder.stop();
  }
  this.clearRecordVoice = function() {
    recorder.clear();
  }
  this.getServerSessions = function(fun) {
    nim.getServerSessions({
      done: fun
    });
  }
  this.getMyInfo = function() {
    return data.myInfo
  }
  this.updateTeam = function(obj) {
    // 目前只需要修改群名
    nim.updateTeam({
      teamId: obj.teamId,
      name: obj.name,
      // avatar: 'avatar',
      // intro: '群简介',
      // announcement: '群公告',
      // joinMode: 'needVerify',
      // custom: '自定义字段',
      done: updateTeamDone
    });
  }
  this.getTeamMembers = function(teamId, fn) {
    if (!data.teamMembers || !data.teamMembers[teamId]) {
      getTeamMemberCallback = fn
      nim.getTeamMembers({
        teamId: teamId,
        done: getTeamMembersDone
      });
      return null
    } else {
      return data.teamMembers[teamId]
    }
  }
  this.getTeamInfo = function(teamId) {
    let ret = data.teams.find(function(x) {
      return x.teamId == teamId;
    })
    return ret
  }
  this.setSessionMessageUpdate = function(sessionid, fun) {
    currentsessionId = sessionid
    onSessionMessageUpdate = fun
  }
  this.setFriendsListUpdateEvent = function(fun) {
    onFriendsListUpdate = fun
  }
  this.setTeamsListUpdateEvent = function(fun) {
    onTeamsListUpdate = fun
  }
  this.setSessionsListUpdateEvent = function(fun) {
    onSessionsListUpdate = fun
  }
  this.setXTTZSessionUpadateEvent = function(fun) {
    onXTTZSessionUpadate = fun
  }
  this.setSendMsgDone = function(fun) {
    onSendMsgDone = fun
  }
  this.onInit = function (username, token, onConnectCallback) {
    let obj = {
      // 初始化SDK
      debug: true,
      appKey: 'febcb3ef218069acf927a617909ea0f8',
      account: username,
      token: token,
      onconnect: onConnect,
      onerror: onError,
      onwillreconnect: onWillReconnect,
      ondisconnect: onDisconnect,
      // 多端登录
      onloginportschange: onLoginPortsChange,
      // 用户关系
      onblacklist: onBlacklist,
      onsyncmarkinblacklist: onMarkInBlacklist,
      onmutelist: onMutelist,
      onsyncmarkinmutelist: onMarkInMutelist,
      // 好友关系
      onfriends: onFriends,
      onsyncfriendaction: onSyncFriendAction,
      // 用户名片
      onmyinfo: onMyInfo,
      onupdatemyinfo: onUpdateMyInfo,
      onusers: onUsers,
      onupdateuser: onUpdateUser,
      // 群组
      onteams: onTeams,
      onsynccreateteam: onCreateTeam,
      onUpdateTeam: onUpdateTeam,
      onteammembers: onTeamMembers,
      // onsyncteammembersdone: onSyncTeamMembersDone,
      onupdateteammember: onUpdateTeamMember,
      // 群消息业务已读通知
      onTeamMsgReceipt: onTeamMsgReceipt,
      // 会话
      onsessions: onSessions,
      onupdatesession: onUpdateSession,
      // 消息
      onroamingmsgs: onRoamingMsgs,
      onofflinemsgs: onOfflineMsgs,
      onmsg: onMsg,
      // 系统通知
      onofflinesysmsgs: onOfflineSysMsgs,
      onsysmsg: onSysMsg,
      onupdatesysmsg: onUpdateSysMsg,
      onsysmsgunread: onSysMsgUnread,
      onupdatesysmsgunread: onUpdateSysMsgUnread,
      onofflinecustomsysmsgs: onOfflineCustomSysMsgs,
      oncustomsysmsg: onCustomSysMsg,
      // 收到广播消息
      onbroadcastmsg: onBroadcastMsg,
      onbroadcastmsgs: onBroadcastMsgs,
      // 同步完成
      onsyncdone: onSyncDone
    }
    if (onConnectCallback) {
      obj.onconnect = onConnectCallback
    }
    nim = SDK.NIM.getInstance(obj)
  }
  this.sentMessage = function(msg, fn) {
    let obj = {
      scene: msg.scene,
      to: msg.to,
      text: msg.text,
      done: sendMsgDone
    }
    if (fn) {
      obj.done = fn
    }
    var msgret = nim.sendText(obj);
    console.log('正在发送p2p text消息, id=' + msgret.idClient);
  }
  this.getLoaclMsg = function(sessionid, fun) {
    nim.getLocalMsgs({
      sessionId: sessionid, // 表示单聊场景(p2p)，对方账号为account。
      limit: 100,
      done: fun
    })
  }
  this.getHistoryMsgs = function(obj, fun) {
    nim.getHistoryMsgs({
      scene: obj.scene,
      to: obj.to,
      done: fun
    });
  }
  this.addFriend = function(obj) {
    editFriendAlias = obj.alias;
    nim.addFriend({
      account: obj.account,
      ps: obj.ps,
      done: addFriendDone
    })
  }
  this.delFriend = function(account) {
    nim.deleteFriend({
      account: account,
      delAlias: false,
      done: deleteFriendDone
    });
  }
  this.getUsers = (accounts, fn) => {
    getUserNick = fn
    nim.getUsers({
      accounts: accounts,
      done: getUsersDone
    });
  }
  function getUsersDone(error, users) {
    console.log(error);
    console.log(users);
    console.log('获取用户资料数组' + (!error ? '成功' : '失败'));
    if (!error) {
      getUserNick(users);
    }
  }
  // 仅删除本地会话
  this.deleteLocalSession = function(sessionid) {
    nim.deleteLocalSession({
      id: sessionid,
      done: deleteLocalSessionDone
    });
  }
  // 主动退群
  this.leaveTeam = function(teamid, fn) {
    nim.leaveTeam({
      teamId: teamid,
      done: fn
    });
  }
  // 解散群
  this.dismissTeam = function(teamId, fn) {
    nim.dismissTeam({
      teamId: teamId,
      done: fn
    });
  }
  // 重置未读数通过sessionid
  this.resetSessionUnread = function(sessionId) {
    nim.resetSessionUnread(sessionId)
  }
  this.updateLocalMsg = function(option) {
    // localCustom: {
    //   'x.accept': 'agree/refused/normal', 系统消息接收/拒绝/未读
    // }
    nim.updateLocalMsg({
      idClient: option.idClient,
      localCustom: option.localCustom,
      done: updateLocalMsgDone
    });
  }
  function updateLocalMsgDone(error, obj) {
    console.log('更新本地消息' + (!error ? '成功' : '失败'), error, obj);
  }
  function deleteFriendDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('删除好友' + (!error ? '成功' : '失败'));
    if (!error) {
      onDeleteFriend(obj.account);
    }
  }
  function getTeamMembersDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('获取群成员' + (!error ? '成功' : '失败'));
    if (!error) {
      if (getTeamMemberCallback) {
        getTeamMemberCallback(obj)
      }
      onTeamMembers(obj);
    }
  }
  function updateTeamDone(error, team) {
    console.log(error);
    console.log(team);
    console.log('更新群' + (!error ? '成功' : '失败'));
  }
  function deleteLocalSessionDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('删除本地会话' + (!error ? '成功' : '失败'));
    var index = data.sessions.findIndex(x => { return x.id === obj.id })
    if (index > -1) {
      data.sessions.splice(index, 1)
    }
    // data.sessions = nim.mergeSessions(data.sessions, obj);
    updateSessionsUI()
  }
  function innerDeleteLocalSessionDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('删除本地会话' + (!error ? '成功' : '失败'));
  }
  // 删除好友时
  this.removeSession = function(account, scene) {
    nim.deleteSession({
      scene: scene,
      to: account,
      done: deleteSessionDone
    });
    if (scene === 'p2p') {
      nim.clearServerHistoryMsgs({
        account: account,
        delRoam: false,
        done: clearServerHistoryMsgsDone
      });
    }
  }
  this.addTeam = function(teamMember, callback) {
    addTeamCallback = callback
    nim.createTeam({
      type: 'normal',
      name: '讨论组',
      avatar: 'avatar',
      accounts: teamMember,
      level: 50,
      ps: '我建了一个讨论组',
      done: createTeamDone
    });
  }
  this.sendImgMsg = function(blob, scene, account) {
    sendBlobMsg(blob, scene, account, 'image')
  }
  this.sendVoiceMsg = function(scene, account) {
    recorder.exportWAV(function (blob) {
      sendBlobMsg(blob, scene, account, 'audio')
    })
  }
  function sendBlobMsg(blob, scene, account, type) {
    nim.previewFile({
      type: type,
      blob: blob,
      uploadprogress: function(obj) {
        console.log('文件总大小: ' + obj.total + 'bytes');
        console.log('已经上传的大小: ' + obj.loaded + 'bytes');
        console.log('上传进度: ' + obj.percentage);
        console.log('上传进度文本: ' + obj.percentageText);
      },
      done: function(error, file) {
        console.log(`上传${type}` + (!error ? '成功' : '失败'));
        // show file to the user
        if (!error) {
          var msg = nim.sendFile({
            scene: scene,
            to: account,
            file: file,
            done: sendMsgDone
          });
          console.log('正在发送p2p image消息, id=' + msg.idClient);
          // pushMsg(msg);
        }
      }
    });
  }
  function createTeamDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('创建' + obj.team.type + '群' + (!error ? '成功' : '失败'));
    if (!error) {
      if (addTeamCallback) {
        addTeamCallback(obj.team)
        addTeamCallback = null
      }
      onCreateTeam(obj.team, obj.owner);
    }
  }
  function deleteSessionDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('删除服务器上的会话' + (!error ? '成功' : '失败'));
  }
  function clearServerHistoryMsgsDone(error, obj) {
    console.log('删除服务器消息' + (!error ? '成功' : '失败'), error, obj);
  }
  function addFriendDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('直接加为好友' + (!error ? '成功' : '失败'));

    updateFriendData(obj.friend.account, '');
    editFriendAlias = '';
    if (!error) {
      onAddFriend(obj.friend);
    }
  }
  // 更新好友信息
  this.updateFriend = function(account, custom) {
    updateFriendData(account, custom)
  }
  function updateFriendData(account, custom) {
    let obj = {account: account, done: updateFriendDone};
    if (editFriendAlias !== '') {
      obj.alias = editFriendAlias
    }
    if (custom !== null && custom !== undefined && custom !== '') {
      obj.custom = custom
    }
    nim.updateFriend(obj);
  }
  // 更新好友信息回调
  function updateFriendDone(error, obj) {
    console.log(error);
    console.log(obj);
    console.log('更新好友' + (!error ? '成功' : '失败'));
    if (!error) {
      onUpdateFriend(obj);
    }
  }
  // function getLocalMsgsDone(error, obj) {
  //     console.log('获取本地消息' + (!error?'成功':'失败'), error, obj)
  // }
  function sendMsgDone(error, msg) {
    console.log(error);
    console.log(msg);
    if (onSendMsgDone) {
      onSendMsgDone(msg)
    }

    console.log('发送' + msg.scene + ' ' + msg.type + '消息' + (!error ? '成功' : '失败') + ', id=' + msg.idClient);
    pushMsg(msg);
  }
  function onConnect() {
    console.log('连接成功');
  }
  function onWillReconnect(obj) {
    // 此时说明 `SDK` 已经断开连接, 请开发者在界面上提示用户连接已断开, 而且正在重新建立连接
    console.log('即将重连');
    console.log(obj.retryCount);
    console.log(obj.duration);
  }
  function onDisconnect(error) {
    // 此时说明 `SDK` 处于断开状态, 开发者此时应该根据错误码提示相应的错误信息, 并且跳转到登录页面
    console.log('丢失连接');
    console.log(error);
    if (error) {
      switch (error.code) {
        // 账号或者密码错误, 请跳转到登录页面并提示错误
        case 302:
          break;
          // 被踢, 请提示错误后跳转到登录页面
        case 'kicked':
          break;
        default:
          break;
      }
    }
  }
  function onError(error) {
    console.log(error);
  }

  function onLoginPortsChange(loginPorts) {
    console.log('当前登录帐号在其它端的状态发生改变了', loginPorts);
  }

  function onBlacklist(blacklist) {
    console.log('收到黑名单', blacklist);
    data.blacklist = nim.mergeRelations(data.blacklist, blacklist);
    data.blacklist = nim.cutRelations(data.blacklist, blacklist.invalid);
    refreshBlacklistUI();
  }
  function onMarkInBlacklist(obj) {
    console.log(obj);
    console.log(obj.account + '被你在其它端' + (obj.isAdd ? '加入' : '移除') + '黑名单');
    if (obj.isAdd) {
      addToBlacklist(obj);
    } else {
      removeFromBlacklist(obj);
    }
  }
  function addToBlacklist(obj) {
    data.blacklist = nim.mergeRelations(data.blacklist, obj.record);
    refreshBlacklistUI();
  }
  function removeFromBlacklist(obj) {
    data.blacklist = nim.cutRelations(data.blacklist, obj.record);
    refreshBlacklistUI();
  }
  function refreshBlacklistUI() {
    // 刷新界面
  }
  function onMutelist(mutelist) {
    console.log('收到静音列表', mutelist);
    data.mutelist = nim.mergeRelations(data.mutelist, mutelist);
    data.mutelist = nim.cutRelations(data.mutelist, mutelist.invalid);
    refreshMutelistUI();
  }
  function onMarkInMutelist(obj) {
    console.log(obj);
    console.log(obj.account + '被你' + (obj.isAdd ? '加入' : '移除') + '静音列表');
    if (obj.isAdd) {
      addToMutelist(obj);
    } else {
      removeFromMutelist(obj);
    }
  }
  function addToMutelist(obj) {
    data.mutelist = nim.mergeRelations(data.mutelist, obj.record);
    refreshMutelistUI();
  }
  function removeFromMutelist(obj) {
    data.mutelist = nim.cutRelations(data.mutelist, obj.record);
    refreshMutelistUI();
  }
  function refreshMutelistUI() {
    // 刷新界面
  }

  function onFriends(friends) {
    console.log('收到好友列表', friends);
    data.friends = nim.mergeFriends(data.friends, friends);
    data.friends = nim.cutFriends(data.friends, friends.invalid);
    refreshFriendsUI();
  }
  function onSyncFriendAction(obj) {
    console.log(obj);
    switch (obj.type) {
      case 'addFriend':
        console.log('你在其它端直接加了一个好友' + obj.account + ', 附言' + obj.ps);
        onAddFriend(obj.friend);
        break;
      case 'applyFriend':
        console.log('你在其它端申请加了一个好友' + obj.account + ', 附言' + obj.ps);
        break;
      case 'passFriendApply':
        console.log('你在其它端通过了一个好友申请' + obj.account + ', 附言' + obj.ps);
        onAddFriend(obj.friend);
        break;
      case 'rejectFriendApply':
        console.log('你在其它端拒绝了一个好友申请' + obj.account + ', 附言' + obj.ps);
        break;
      case 'deleteFriend':
        console.log('你在其它端删了一个好友' + obj.account);
        onDeleteFriend(obj.account);
        break;
      case 'updateFriend':
        console.log('你在其它端更新了一个好友', obj.friend);
        onUpdateFriend(obj.friend);
        break;
    }
  }
  function onAddFriend(friend) {
    data.friends = nim.mergeFriends(data.friends, friend);
    refreshFriendsUI();
  }
  function onDeleteFriend(account) {
    data.friends = nim.cutFriendsByAccounts(data.friends, account);
    refreshFriendsUI();
  }
  function onUpdateFriend(friend) {
    data.friends = nim.mergeFriends(data.friends, friend);
    refreshFriendsUI();
  }
  function refreshFriendsUI() {
    // 刷新界面
    if (onFriendsListUpdate != null) {
      onFriendsListUpdate(data.friends)
    }
  }

  function onMyInfo(user) {
    console.log('收到我的名片', user);
    data.myInfo = user;
    updateMyInfoUI();
  }
  function onUpdateMyInfo(user) {
    console.log('我的名片更新了', user);
    data.myInfo = SDK.NIM.util.merge(data.myInfo, user);
    updateMyInfoUI();
  }
  function updateMyInfoUI() {
    // 刷新界面
  }
  function onUsers(users) {
    console.log('收到用户名片列表', users);
    data.users = nim.mergeUsers(data.users, users);
  }
  function onUpdateUser(user) {
    console.log('用户名片更新了', user);
    data.users = nim.mergeUsers(data.users, user);
  }
  function onTeams(teams) {
    console.log('群列表', teams);
    data.teams = nim.mergeTeams(data.teams, teams);
    onInvalidTeams(teams.invalid);
  }
  function onInvalidTeams(teams) {
    data.teams = nim.cutTeams(data.teams, teams);
    data.invalidTeams = nim.mergeTeams(data.invalidTeams, teams);
    refreshTeamsUI();
  }
  function onCreateTeam(team, owner) {
    console.log('你创建了一个群', team);
    data.teams = nim.mergeTeams(data.teams, team);
    refreshTeamsUI();
    onTeamMembers({
      teamId: team.teamId,
      members: owner
    });
  }
  function refreshTeamsUI() {
    // 刷新群组界面
    if (onTeamsListUpdate) {
      onTeamsListUpdate(data.teams)
    }
  }
  function onTeamMembers(teamId, members) {
    console.log('群id', teamId, '群成员', members);
    // var teamId = obj.teamId;
    // var members = obj.members;
    data.teamMembers = data.teamMembers || {};
    data.teamMembers[teamId] = nim.mergeTeamMembers(data.teamMembers[teamId], members);
    data.teamMembers[teamId] = nim.cutTeamMembers(data.teamMembers[teamId], members.invalid);
    refreshTeamMembersUI();
  }
  // function onSyncTeamMembersDone() {
  //     console.log('同步群列表完成');
  // }
  function onUpdateTeam (team) {
    let index = data.teams.findIndex((x) => {
      return x.teamId === team.teamId
    })
    if (index > -1) {
      data.teams.splice(index, 1, team)// 替换
    }
    console.log('群状态更新', team)
  }
  function onUpdateTeamMember(teamMember) {
    console.log('群成员信息更新了', teamMember);
    onTeamMembers({
      teamId: teamMember.teamId,
      members: teamMember
    });
  }
  function refreshTeamMembersUI() {
    // 刷新界面
  }
  function onTeamMsgReceipt (teamMsgReceipts) {
    console.log('群消息已读通知', teamMsgReceipts)
  }

  function onSessions(sessions) {
    console.log('收到会话列表', sessions);
    let newSessions = []
    // 这边做下处理，目前如果收到讨论组解散那么就删除本地会话
    for (let i = 0; i < sessions.length; i++) {
      if (sessions[i].lastMsg.attach && sessions[i].lastMsg.attach.type) {
        if (sessions[i].lastMsg.attach.type === 'dismissTeam') {
          nim.deleteLocalSession({
            id: sessions[i].id,
            done: innerDeleteLocalSessionDone
          });
        } else if (sessions[i].lastMsg.attach.type === 'leaveTeam') {
          if (sessions[i].lastMsg.from !== data.myInfo.account) { newSessions.push(sessions[i]) }
        } else {
          newSessions.push(sessions[i])
        }
      } else if (sessions[i].to === '999999999') {
        // 默认系统通知账户为‘999999999’
        updateXTTZSessionUI(sessions[i])
      } else {
        newSessions.push(sessions[i])
      }
    }
    data.sessions = nim.mergeSessions(data.sessions, newSessions);
    console.log('收到会话列表data', data)
    updateSessionsUI();
  }
  function updateXTTZSessionUI(session) {
    if (onXTTZSessionUpadate != null) {
      //
      onXTTZSessionUpadate(session)
    }
  }
  function onUpdateSession(session) {
    console.log('会话更新了', session);
    if (session.scene === 'team' && session.lastMsg.attach && session.lastMsg.attach.type) {
      // 当前解散的话就不需要在界面上展示了，以后可能需要修改
      // 如果当前会话不存在的话就直接返回。如果存在就删除再刷新界面
      let index = data.sessions.findIndex((x) => {
        return x.sessionId === session.sessionId
      })
      if (session.lastMsg.attach.type === 'dismissTeam') {
        if (index > -1) {
          data.sessions.splice(index, 1)
          updateSessionsUI();
        }
      } else if (session.lastMsg.attach.type === 'leaveTeam') {
        if (index > -1 && currentsessionId === session.sessionId) {
          data.sessions.splice(index, 1)
          updateSessionsUI();
        }
      }
      return
    } else if (session.to === '999999999') {
      // 默认系统通知账户为‘999999999’
      updateXTTZSessionUI(session)
      return
    }
    data.sessions = nim.mergeSessions(data.sessions, session);
    updateSessionsUI();
  }
  function updateSessionsUI() {
    // 刷新界面
    if (onSessionsListUpdate != null) {
      //
      onSessionsListUpdate(data.sessions)
    }
  }

  function onRoamingMsgs(obj) {
    console.log('漫游消息', obj);
    pushMsg(obj.msgs);
  }
  function onOfflineMsgs(obj) {
    console.log('离线消息', obj);
    pushMsg(obj.msgs);
  }
  function onMsg(msg) {
    console.log('收到消息', msg.scene, msg.type, msg);
    if (msg.scene === 'team' && msg.type === 'notification' && msg.attach) {
      let index = data.teams.findIndex((x) => {
        return x.teamId === msg.to
      })
      if (msg.attach.type === 'dismissTeam') {
        // 这里收到消息说讨论组解散了。那么刷新讨论组列表界面
        if (index > -1) {
          data.teams.splice(index, 1)
        }
      } else if (msg.attach.type === 'addTeamMembers') {
        if (index === -1) {
          data.teams.push(msg.attach.team)
        }
      } else if (msg.attach.type === 'leaveTeam') {
        if (msg.from === data.myInfo.account && index > -1) {
          data.teams.splice(index, 1)
        }
      }
      refreshTeamsUI()
    }
    pushMsg(msg);
  }
  function onBroadcastMsg(msg) {
    console.log('收到广播消息', msg);
  }
  function onBroadcastMsgs(msgs) {
    console.log('收到广播消息列表', msgs);
  }
  function pushMsg(msgs) {
    if (!Array.isArray(msgs)) { msgs = [msgs]; }
    var sessionId = msgs[0].sessionId;
    data.msgs = data.msgs || {};
    data.msgs[sessionId] = nim.mergeMsgs(data.msgs[sessionId], msgs);
    if (currentsessionId === sessionId && onSessionMessageUpdate) {
      onSessionMessageUpdate(msgs[0])
    }
  }

  function onOfflineSysMsgs(sysMsgs) {
    console.log('收到离线系统通知', sysMsgs);
    pushSysMsgs(sysMsgs);
  }
  function onSysMsg(sysMsg) {
    console.log('收到系统通知', sysMsg)
    pushSysMsgs(sysMsg);
  }
  function onUpdateSysMsg(sysMsg) {
    pushSysMsgs(sysMsg);
  }
  function pushSysMsgs(sysMsgs) {
    data.sysMsgs = nim.mergeSysMsgs(data.sysMsgs, sysMsgs);
    if (sysMsgs.type === 'addFriend') {
      data.friends.push(sysMsgs.friend)
      refreshFriendsUI()
    } else if (sysMsgs.type === 'deleteFriend') {
      let index = data.friends.findIndex((x) => {
        return x.account === sysMsgs.from
      })
      if (index > -1) {
        data.friends.splice(index, 1)
        refreshFriendsUI()
      }
    }
    refreshSysMsgsUI();
  }
  function onSysMsgUnread(obj) {
    console.log('收到系统通知未读数', obj);
    data.sysMsgUnread = obj;
    refreshSysMsgsUI();
  }
  function onUpdateSysMsgUnread(obj) {
    console.log('系统通知未读数更新了', obj);
    data.sysMsgUnread = obj;
    refreshSysMsgsUI();
  }
  function refreshSysMsgsUI() {
    // 刷新界面
    refreshTeamsUI()
    updateSessionsUI()
  }
  function onOfflineCustomSysMsgs(sysMsgs) {
    console.log('收到离线自定义系统通知', sysMsgs);
  }
  function onCustomSysMsg(sysMsg) {
    console.log('收到自定义系统通知', sysMsg);
  }

  function onSyncDone() {
    console.log('同步完成');
  }
  this.onDispose = function() {
    nim.destroy({
      done: function (err) {
        console.log(err)
        console.log('实例已被完全清除')
      }
    })
  }
}
export {
  NIMCoreClass
}
